package com.talanx.harpoon.process.multiinstance;

import java.util.logging.Logger;

import javax.inject.Named;

import org.camunda.bpm.engine.impl.bpmn.behavior.AbstractBpmnActivityBehavior;
import org.camunda.bpm.engine.impl.pvm.delegate.ActivityExecution;

/**
 * This is an empty service implementation illustrating how to use a plain Java 
 * class as a BPMN 2.0 Service Task delegate.
 */
@Named("logger")
public class LoggerDelegate extends AbstractBpmnActivityBehavior {
 
  private final Logger LOGGER = Logger.getLogger(LoggerDelegate.class.getName());
  
	@Override
	public void execute(ActivityExecution execution) throws Exception {
    this.LOGGER.info("\n\n  ... LoggerDelegate invoked by "
            + "processDefinitionId=" + execution.getProcessDefinitionId()
            + ", activtyId=" + execution.getCurrentActivityId()
            + ", activtyName='" + execution.getCurrentActivityName() + "'"
            + ", processInstanceId=" + execution.getProcessInstanceId()
            + ", businessKey=" + execution.getProcessBusinessKey()
            + ", executionId=" + execution.getId()
            + " \n\n");
  }

	@Override
	public void signal(ActivityExecution execution, String signalName, Object signalData) throws Exception {
		this.leave(execution);
	}

}
